## sdcc 4.2.0~osmocom3.113.9edd

=== debian/changelog ===
sdcc (4.2.0~osmocom3.113.9edd) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom master feed

 -- Osmocom OBS scripts <info@osmocom.org>  Mon, 29 Sep 2025 07:20:34 +0000

sdcc (4.2.0~osmocom3) unstable; urgency=medium

  * debian: don't build documentation

 -- Oliver Smith <osmith@sysmocom.de>  Mon, 29 Sep 2025 09:17:52 +0200

=== debian/control ===
Source: sdcc
Section: electronics
Priority: optional
Maintainer: Osmocom team <openbsc@lists.osmocom.org>
Uploaders: Gudjon I. Gudjonsson <gudjon@gudjon.org>,
	Jonathan McDowell <noodles@earth.li>
Build-Depends: bison,
               debhelper (>= 10),
               dpkg-dev (>= 1.16.1~),
               flex,
               gputils,
               libboost-dev,
               libncurses5-dev,
               libtool,
               zlib1g-dev
Standards-Version: 4.4.1
Homepage: http://sdcc.sourceforge.net
Vcs-Git: https://salsa.debian.org/electronics-team/sdcc.git
Vcs-Browser: https://salsa.debian.org/electronics-team/sdcc

Package: sdcc
Architecture: any
Depends: sdcc-libraries (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: python, sdcc-ucsim
Breaks: sdcc-ucsim (<< 3.5.0)
Replaces: sdcc-ucsim (<< 3.5.0)
Description: Small Device C Compiler
 SDCC is a C compiler for the Intel MCS51 family, HC08, PIC,
 GameBoy Z80, DS80S390, Z80, Z180 and STM8 microcontrollers.
 .
 This package includes the compiler, assemblers and linkers.

Package: sdcc-libraries
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: gputils
Description: Small Device C Compiler (libraries)
 SDCC is a C compiler for the Intel MCS51 family, HC08, PIC,
 GameBoy Z80, DS80S390, Z80, Z180 and STM8 microcontrollers.
 .
 This package contains the core library for SDCC.

Package: sdcc-ucsim
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: sdcc
Replaces: sdcc-ucsim-snapshot
Description: Micro-controller simulator for SDCC
 uCsim is a microcontroller simulator. It is extensible to support
 different microcontroller families. It currently supports Intel
 MCS51 family, HC08 and Z80 microcontrollers.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS := hardening=+pie,+bindnow
export CPPFLAGS=$(shell dpkg-buildflags --get CPPFLAGS)
export CFLAGS=$(shell dpkg-buildflags --get CFLAGS)
export CXXFLAGS=$(shell dpkg-buildflags --get CXXFLAGS)
export LDFLAGS=$(shell dpkg-buildflags --get LDFLAGS)

# GCC 15 changes the default to C23, breaking this version of SDCC. Revert it.
# https://www.gnu.org/software//gcc/gcc-15/porting_to.html#c23
CFLAGS += -std=gnu17

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
	NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

export HOME=$(CURDIR)/build

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -g -O0
	export STRIP=true
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

clean:
	dh_testdir
	dh_testroot
	[ ! -f Makefile ] || $(MAKE) distclean
	rm -rf $(CURDIR)/build
	rm -f support/sdbinutils/binutils/arlex.c
	rm -f support/sdbinutils/binutils/arparse.c
	rm -f support/sdbinutils/binutils/arparse.h
	rm -f confdefs.h
	rm -f install-arch install-indep
	rm -f doc/sdcc_version
	rm -f sim/ucsim/cmd.src/cmdlex.cc
	rm -f device/lib/stm8-large/Makefile
	rm -f device/lib/stm8-large/*.asm
	rm -f device/lib/stm8-large/*.lst
	rm -f device/lib/stm8-large/*.rel
	rm -f device/lib/stm8-large/*.sym
	rm -f support/sdbinutils/binutils/mcparse.[c,h]
	rm -f support/sdbinutils/binutils/rcparse.[c,h]
	rm -f support/sdbinutils/binutils/sysinfo.[c,h]
	rm -f support/sdbinutils/binutils/syslex.[c,h]
	rm -f support/sdbinutils/binutils/defparse.[c,h]
	rm -f sim/ucsim/config.log
	rm -f sim/ucsim/lex.yy.c
	rm -f support/sdbinutils/bfd/doc/bfd.info
	rm -f support/sdbinutils/bfd/doc/bfdver.texi
	find . -type f -name 'Makefile' -exec rm -vf {} \;
	find . -type f -name 'config.log' -exec rm -vf {} \;
	dh_clean

configure: configure-stamp
configure-stamp:
	dh_testdir
	mkdir -p $(CURDIR)/build
	chmod a-x device/lib/*.c
	dh_update_autotools_config
	CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" CXXFLAGS="$(CXXFLAGS)" LDFLAGS="$(LDFLAGS)" \
	./configure \
		--host=$(DEB_HOST_GNU_TYPE) \
		--build=$(DEB_BUILD_GNU_TYPE) \
		--disable-non-free \
		--disable-pic14-port \
		--disable-pic16-port \
		--prefix=/usr
	touch $@

build: build-arch build-indep
build-arch: build-arch-stamp
build-arch-stamp: configure-stamp 
	dh_testdir
	$(MAKE) $(NJOBS)
	touch $@

build-indep: build-indep-stamp
build-indep-stamp: configure-stamp
	dh_testdir
	touch $@

install: install-arch install-indep
install-indep: build
	dh_testdir
	dh_testroot
	dh_installdirs 
	dh_prep
	$(MAKE) install prefix=$(CURDIR)/debian/tmp/usr
	#Remove extra license file
	rm -f $(CURDIR)/debian/tmp/usr/share/sdcc/lib/src/pic16/COPYING
	# Remove empty dirs:
	find $(CURDIR)/debian/tmp -type d -empty -delete

	#Clean up unnecessary directories
	rm -rf `find $(CURDIR)/debian/tmp -type d -name .deps`

	dh_install -i
	dh_missing --list-missing

	# Install examples
	#cp -a device/examples $(CURDIR)/debian/sdcc-doc/usr/share/doc/sdcc-doc
	rm -f $(CURDIR)/debian/sdcc-doc/usr/share/doc/sdcc-doc/examples/mcs51/simple*/go*
	rm -f debian/sdcc-libraries/usr/share/sdcc/lib/src/pic14/GPL
	rm -f debian/sdcc-libraries/usr/share/sdcc/lib/src/pic14/LGPL

	touch $@

install-arch: build-arch
	dh_testdir
	dh_testroot
	dh_installdirs 
	dh_prep
	$(MAKE) install prefix=$(CURDIR)/debian/tmp/usr
	rm -f $(CURDIR)/debian/tmp/usr/bin/sdld6808
	cd $(CURDIR)/debian/tmp/usr/bin/ && ln -s sdld sdld6808
	rm -f $(CURDIR)/debian/tmp/usr/bin/sdldgb
	cd $(CURDIR)/debian/tmp/usr/bin/ && ln -s sdld sdldgb
	rm -f $(CURDIR)/debian/tmp/usr/bin/sdldpdk
	cd $(CURDIR)/debian/tmp/usr/bin/ && ln -s sdld sdldpdk
	rm -f $(CURDIR)/debian/tmp/usr/bin/sdldstm8
	cd $(CURDIR)/debian/tmp/usr/bin/ && ln -s sdld sdldstm8
	rm -f $(CURDIR)/debian/tmp/usr/bin/sdldz80
	cd $(CURDIR)/debian/tmp/usr/bin/ && ln -s sdld sdldz80

	# Remove empty dirs:
	find $(CURDIR)/debian/tmp -type d -empty -delete

	#Clean up unnecessary directories
	rm -rf `find $(CURDIR)/debian/tmp -type d -name .deps`
	# Add some scripts
	mkdir -p debian/tmp/usr/share/sdcc/scripts
	install -m 755  support/scripts/*.pl debian/tmp/usr/share/sdcc/scripts
	install -m 755  support/scripts/*.py debian/tmp/usr/share/sdcc/scripts
	# Remove an unnecessary script 
	rm -f debian/tmp/usr/share/sdcc/scripts/gen_known_bugs.pl
	dh_install -a --sourcedir=debian/tmp --list-missing

	touch $@

# Must not depend on anything. This is to be called by binary-arch/binary-indep
# in another 'make' thread.
binary-common:
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installman
	#dh_installexamples -psdcc-doc device/examples/* -X\.bat  
	dh_installemacsen
	dh_link
	dh_lintian
	dh_strip -Xusr/share/sdcc/lib/
	dh_compress --exclude=.c --exclude=.h --exclude=.cpp
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# Build architecture-independent files here.
binary-indep: install-indep
	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common

# Build architecture-dependent files here.
binary-arch: install-arch
	$(MAKE) -f debian/rules DH_OPTIONS=-s binary-common

get-orig-source:
	set -e;\
	VER=$(DEB_VERSION_UPSTREAM);\
	uscan --force-download --rename --download-version=$$VER --destdir=. && (\
	tar -xj --exclude device/non-free --exclude sim/ucsim/libltdl -f sdcc_$$VER.orig.tar.bz2 ; \
	mv sdcc-$$VER sdcc-$$VER+dfsg;\
	tar -caf sdcc_$$VER+dfsg.orig.tar.xz sdcc-$$VER+dfsg; \
	rm -rf sdcc-$$VER+dfsg ;\
	rm -f sdcc_$$VER.orig.tar.bz2);

binary: binary-arch binary-indep
.PHONY: build clean binary-indep binary-arch binary install install-arch install-indep

## sdcc 4.2.0+dfsg

=== src/regression/Makefile ===
# Regression testing Makefile for Pic Port of SDCC
#
# note that this regression suite was started before
# the one in sdcc/regression. The regression suite in
# sdcc/regression is better suited for testing mature
# ports.
#
# GPL'd
#
# T. Scott Dattalo scott@dattalo.com
#
# This makefile provides a means by which the output
# of the SDCC Compiler can be tested. This version
# is unique to the PIC (as in Microchip PIC) port.
# As such it requires the following software:
#
#  gpasm version 0.11.1 (or greater)
#  gpsim version 0.20.7 (or greater)
#
# Usage: make without options shows it

############################################################
# Configuration

# Uncomment this to show only errors.
# Comment this out for debugging.
.SILENT:

# default verbose mode
VERBOSE ?= 0

# default debug mode
DEBUG ?= 0

# List of targets
# You can prefix any target name with a dash to disable it
TARGETS ?= $(sort $(filter pic%, pic14 pic14e -pic14o -pic14eo -pic14x -pic14ex -pic14ox -pic14eox -pic16 ))

# List of C files to be tested
TESTS ?= $(sort $(notdir $(wildcard $(srcdir)/*.c)))

############################################################
# Directories

builddir = .
top_builddir = $(builddir)/../../../..

srcdir := $(dir $(lastword $(MAKEFILE_LIST)))
top_srcdir = $(srcdir)/../..

############################################################
# Other settings

# The session is saved here:
SESSIONLOG = make.log

# Results of the test are placed here:
LOGFILE = test.log

# Script file for creating gpsim scripts
CREATESTC = create_stc

# Script file for invoking gpsim
SIMULATE = simulate

STC = $(patsubst %.c, %.stc, $(TESTS))

############################################################
# Architecture and target specific settings

# pic16 architecture
ifneq (,$(filter pic16,$(TARGET)))
ARCH = pic16
DEV ?= 18f452
endif

# pic14 architecture
ifneq (,$(filter pic14%,$(TARGET)))
ARCH = pic14

# regular/enhanced core
LIB_E = $(findstring e,$(TARGET))

# optimizations enabled/disabled
LIB_O = $(findstring o,$(TARGET))

# experimental code disabled/enabled
LIB_X = $(findstring x,$(TARGET))

ifeq (e,$(strip $(LIB_E)))
# pic14 enhanced device
# the defaut device for enhanced cores in SDCC is the 16f1934,
# but it is not supported by gpsim, so we use here the 16f1788,
# which in fact has more ROM and RAM memory
DEV ?= 16f1788
else
# pic14 non-enhanced device
DEV ?= 16f877
endif

endif

############################################################
# Toolchain

# toolchain
CC = $(top_builddir)/bin/sdcc

# compiler options
CFLAGS =  --no-warn-non-free -m$(ARCH) -p$(DEV) --fsigned-char --i-code-in-asm --fverbose-asm --std-c99
CFLAGS += --nostdinc -I$(top_srcdir)/device/include/$(ARCH) -I$(top_srcdir)/device/non-free/include/$(ARCH) -I$(top_srcdir)/device/include

# linker options (for sdcc)
CFLAGS += -Wl,-l,-O2
CFLAGS += --nostdlib -L$(top_builddir)/device/lib/build/$(ARCH) -L$(top_builddir)/device/non-free/lib/build/$(ARCH)

# linker libraries
LIB_SUFFIX = $(LIB_E)$(LIB_O)$(LIB_X)
CFLAGS += -l libsdcc$(LIB_SUFFIX).lib

############################################################
# Build alternatives

ifeq (e,$(strip $(LIB_E)))
# pic14 enhanced architecture
#CFLAGS += --no-extended-instructions
else
# pic14 non-enhanced architecture
endif

ifeq (o,$(strip $(LIB_O)))
# disable optimizations
CFLAGS += -D__SDCC_PIC14_NOOPTS
CFLAGS += --no-pcode-opt --no-peep
else
# enable optimizations
#CFLAGS += --opt-code-size
endif

ifeq (x,$(strip $(LIB_X)))
# enable experimental options
CFLAGS += -D__SDCC_PIC14_EXPERIMENTAL
CFLAGS += --experimental-pcall-all --experimental-pcall-enhanced --experimental-variadics --experimental-ralloc
# gpsim fails to place breakpoints when gplink optimizations are enabled
#CFLAGS += -Wl,-b1,-p1,-B,-P,-W
ifeq (1,$(strip $(DEBUG)))
CFLAGS += --debug-variadics
endif
else
# disable experimental options
endif

ifeq (1,$(strip $(VERBOSE)))
# enable verbose
Q ?=
CFLAGS += -V --verbose
else
# disable verbose
Q ?= @
#CFLAGS += -Wl,-q
endif

ifeq (1,$(strip $(DEBUG)))
# enable debug
CFLAGS += --debug --debug-xtra --debug-glue --debug-ralloc
CFLAGS += -Wl,-m
# this gplink option dumps too much data. not enabled by default.
#CFLAGS += -Wl,--debug
else
# disable debug
#CFLAGS += -Wl,-q
endif

############################################################
# Rules

all: help

# make without arguments shows this help
help:
	@echo "make test           test all targets"
	@echo "make test-TARGET    test one target"
	@echo "make clean          clean all targets"
	@echo "make clean-TARGET   clean one target"
	@echo
	@echo "Available targets: $(TARGETS)"

# Test all targets
test: $(patsubst %,test-%,$(TARGETS))
	@echo "Summary of all targets:"
	@for target in $(TARGETS) ; do \
	    printf "%-20s %s\n" $$target "` grep Total tests/$$target/$(SESSIONLOG) `" ; \
	done

# Clean all targets
clean: $(patsubst %,clean-%,$(TARGETS))

# Rules for each target: test-TARGET and clean-TARGET

define target-rules
test-$(1): Makefile $$(TESTS)
	@echo "Testing target $(1)"
	@[ -d tests ] || mkdir tests
	@[ -d tests/$(1) ] || mkdir tests/$(1)
	$$(Q)$$(MAKE) TARGET=$(1) -f ../../Makefile -C tests/$(1) test-target 2>&1 | tee tests/$(1)/$$(SESSIONLOG)

clean-$(1):
	@if [ -d tests/$(1) ] ; then \
	    echo "Cleaning target $(1)" ; \
	    rm -rf tests/$(1) ; \
	    if [ ` ls tests | wc -l ` -eq 0 ] ; then \
	        rmdir tests ; \
	    fi ; \
	fi

endef

$(foreach TARGET,$(TARGETS),$(eval $(call target-rules,$(TARGET))))

# Remove noise from gplink
FILTER_NOISE = | grep -v '^message: Using default linker script'

# The .cod files are generated by sdcc
%.cod: $(srcdir)/%.c
	$(Q)-$(CC) $(CFLAGS) $< $(FILTER_NOISE) 2>&1 | tee $*.log

# The .stc files are script files for gpsim
%.stc: %.cod
	$(Q)-$(srcdir)/$(CREATESTC) $< $@
	$(Q)-$(srcdir)/$(SIMULATE) $@ $(LOGFILE)

# Show info about the test before starting it
test-info:
	@echo "TARGET: $(TARGET) ARCH: $(ARCH) DEV: $(DEV) LIB: libsdcc$(LIB_SUFFIX).lib"
	@echo "LOGFILE: $(LOGFILE) SESSIONLOG: $(SESSIONLOG)"
	@echo "srcdir: $(srcdir)"
	@echo "top_srcdir: $(top_srcdir)"
	@echo "builddir: $(builddir)"
	@echo "top_builddir: $(top_builddir)"
	@echo "TEST_DIR: $(shell pwd)"
	@echo "TESTS: $(TESTS)"
	@echo "CFLAGS: $(CFLAGS)"

# Run all tests for one target
ifeq (1,$(strip $(VERBOSE)))
test-target: test-info $(STC)
	@echo "Done - Total tests: ` cat $(LOGFILE) | wc -l ` Failures: ` grep FAILED $(LOGFILE) | wc -l `"
	@echo "Done - Each TEST is logged in tests/$(TARGET)/TEST.log"
	@echo "Done - This session has been saved in tests/$(TARGET)/$(SESSIONLOG)"
	@echo "Done - Results summary is in tests/$(TARGET)/$(LOGFILE)"
else
test-target: $(STC)
	@echo "Done - Total tests: ` cat $(LOGFILE) | wc -l ` Failures: ` grep FAILED $(LOGFILE) | wc -l `"
endif

.SUFFIXES: .asm .c .cod .stc
.NOTPARALLEL:
.PRECIOUS: %.cod
.PHONY: all test clean help $(patsubst %,test-% clean-%,$(TARGETS)) test-info test-target

=== sim/ucsim/test/Makefile ===
PROJECTS	= t1 stck_ovf

.PHONY: projects $(PROJECTS)

projects: $(PROJECTS)

$(PROJECTS):
	$(MAKE) MAIN=$@ -f sdcc.mk

clean:
	for p in $(PROJECTS); do \
		$(MAKE) MAIN=$$p -f sdcc.mk clean ;\
		rm -rf $$p*.hex ;\
		rm -rf $$p*.cdb ;\
	done

=== support/tests/dhrystone/Makefile ===
# Simple Makefile for dhrystone and sdcc
TOPDIR = ../../..

PROC = z80

CC = $(TOPDIR)/bin/sdcc

# -DNOENUM is here to make the results more predictable
CFLAGS += -DREG= -DNOSTRUCTASSIGN -DNOENUM -V -m$(PROC) --profile --dumpall --stack-auto

OBJ = dhry.o

all: dhry.bin

dhry.ihx: dhry.c
	$(CC) $(CFLAGS) dhry.c

dhry.gb: dhry.c
	$(CC) $(CFLAGS) dhry.c

dhry.c: dhry.h

dhry.bin: dhry.ihx
	cat $< | $(TOPDIR)/bin/makebin > $@

native:
	gcc -g -O2 -DREG= -DNOSTRUCTASSIGN -DNOENUM -o dhry dhry.c

clean:
	rm -f *~ dhry *.o *.gb *.ihx *.rel *.dump* *.lst *.sym *.map *.asm *.bin *.gb

=== sim/ucsim/avr.src/test/config/Makefile ===
OUTPUTS = AVR


$(OUTPUTS):
	$(call run-sim, -e 'conf; info reg; info mem')


include test-lib.mk

=== sim/ucsim/m6800.src/test/config/Makefile ===
OUTPUTS = M6800


$(OUTPUTS):
	$(call run-sim, -e 'conf; info reg; info mem')


include test-lib.mk

=== sim/ucsim/p1516.src/test/config/Makefile ===
OUTPUTS = P1516


$(OUTPUTS):
	$(call run-sim, -e 'conf; info reg; info mem')


include test-lib.mk

=== sim/ucsim/s51.src/test/banker/Makefile ===
OUTPUTS = C51 517


$(OUTPUTS): %:	test-%.cmd
	$(call run-sim, -t $@)


include test-lib.mk

=== sim/ucsim/s51.src/test/symdis/Makefile ===
OUTPUTS = 8751 DS390F


# Ignore changes in white space. The field widths for labels
# depends on the length of the longest label. This will be
# different for different simulators and should not be assumed
# to be constant for any given simulator.
DIFF_OPTS += -b


$(OUTPUTS): %:	test-%.ihx test-%.cmd
	$(call run-sim, -t '$@')


include test-lib.mk

=== sim/ucsim/stm8.src/test/bitaddr/Makefile ===
OUTPUTS = stdout


# Ignore changes in white space. The field widths for labels
# depends on the length of the longest label. This will be
# different for different simulators and should not be assumed
# to be constant for any given simulator.
DIFF_OPTS += -b


stdout: test.cmd
	@$(call run-sim)


include test-lib.mk

=== sim/ucsim/stm8.src/test/symdis/Makefile ===
OUTPUTS = stdout


# Ignore changes in white space. The field widths for labels
# depends on the length of the longest label. This will be
# different for different simulators and should not be assumed
# to be constant for any given simulator.
DIFF_OPTS += -b


stdout:	xconnect.ihx xconnect.vars test.cmd
	@$(call run-sim, -t S003 '$(srcdir)/xconnect.ihx' -e 'exec "$(srcdir)/xconnect.vars"')


include test-lib.mk

=== sim/ucsim/tlcs.src/test/config/Makefile ===
OUTPUTS = TLCS


$(OUTPUTS):
	$(call run-sim, -e 'conf; info reg; info mem')


include test-lib.mk

=== sim/ucsim/z80.src/test/symdis/Makefile ===
OUTPUTS = stdout


# Ignore changes in white space. The field widths for labels
# depends on the length of the longest label. This will be
# different for different simulators and should not be assumed
# to be constant for any given simulator.
DIFF_OPTS += -b


stdout:	test.ihx test.cmd
	$(call run-sim, -t Z80)


include test-lib.mk

=== debian/rules ===
--- 
+++ 
@@ -9,10 +9,6 @@
 export CFLAGS=$(shell dpkg-buildflags --get CFLAGS)
 export CXXFLAGS=$(shell dpkg-buildflags --get CXXFLAGS)
 export LDFLAGS=$(shell dpkg-buildflags --get LDFLAGS)
-
-# GCC 15 changes the default to C23, breaking this version of SDCC. Revert it.
-# https://www.gnu.org/software//gcc/gcc-15/porting_to.html#c23
-CFLAGS += -std=gnu17
 
 # These are used for cross-compiling and for saving the configure script
 # from having to guess our platform (since we know it already)
@@ -89,6 +85,7 @@
 build-indep: build-indep-stamp
 build-indep-stamp: configure-stamp
 	dh_testdir
+	cd doc && make
 	touch $@
 
 install: install-arch install-indep
@@ -98,6 +95,11 @@
 	dh_installdirs 
 	dh_prep
 	$(MAKE) install prefix=$(CURDIR)/debian/tmp/usr
+	mkdir -p debian/tmp/usr/share/doc/sdcc-doc
+	install -o root -g root -m 644 doc/sdccman.pdf debian/tmp/usr/share/doc/sdcc-doc
+	mv debian/tmp/usr/share/doc/sdcc/* debian/tmp/usr/share/doc/sdcc-doc/
+	rm -f debian/tmp/usr/share/doc/sdcc-doc/z80/combined_i186_z80_design.tex
+	rm -f debian/tmp/usr/share/doc/sdcc-doc/z80/Makefile
 	#Remove extra license file
 	rm -f $(CURDIR)/debian/tmp/usr/share/sdcc/lib/src/pic16/COPYING
 	# Remove empty dirs:
@@ -141,8 +143,8 @@
 	rm -rf `find $(CURDIR)/debian/tmp -type d -name .deps`
 	# Add some scripts
 	mkdir -p debian/tmp/usr/share/sdcc/scripts
-	install -m 755  support/scripts/*.pl debian/tmp/usr/share/sdcc/scripts
-	install -m 755  support/scripts/*.py debian/tmp/usr/share/sdcc/scripts
+	install -o root -g root -m 755  support/scripts/*.pl debian/tmp/usr/share/sdcc/scripts
+	install -o root -g root -m 755  support/scripts/*.py debian/tmp/usr/share/sdcc/scripts
 	# Remove an unnecessary script 
 	rm -f debian/tmp/usr/share/sdcc/scripts/gen_known_bugs.pl
 	dh_install -a --sourcedir=debian/tmp --list-missing
@@ -155,6 +157,7 @@
 	dh_testdir
 	dh_testroot
 	dh_installchangelogs ChangeLog
+	dh_installdocs
 	dh_installman
 	#dh_installexamples -psdcc-doc device/examples/* -X\.bat  
 	dh_installemacsen

## sdcc 4.4.0%2Bdfsg

=== sim/ucsim/mos6502.src/test/config/Makefile ===
OUTPUTS = MOS6502


$(OUTPUTS):
	$(call run-sim, -e 'conf; info reg; info mem')


include test-lib.mk

=== sim/ucsim/stm8.src/test/vcd-op/Makefile ===
OUTPUTS = stdout


$(OUTPUTS):	test.cmd
	$(call run-sim)


include test-lib.mk

## sdcc 4.4.0+dfsg

=== src/regression/Makefile ===
--- 
+++ 
@@ -89,7 +89,7 @@
 
 ifeq (e,$(strip $(LIB_E)))
 # pic14 enhanced device
-# the defaut device for enhanced cores in SDCC is the 16f1934,
+# the default device for enhanced cores in SDCC is the 16f1934,
 # but it is not supported by gpsim, so we use here the 16f1788,
 # which in fact has more ROM and RAM memory
 DEV ?= 16f1788

=== sim/ucsim/example/Makefile ===
PRJ		= simif banking

all:
	for p in $(PRJ); do \
		$(MAKE) -f $$p.mk; \
	done

clean:
	for p in $(PRJ); do \
		$(MAKE) -f $$p.mk clean; \
	done

#all: simif.ihx
#
#simif.ihx: simif.c
#	sdcc --model-large --debug simif.c
#
#clean:
#	rm -f *.asm *.ihx *.lk *.lst *.map *.mem *.rel *.rst *.sym
#	rm -f *.adb *.cdb *.omf
#	rm -f simif.out simif_fout.txt

=== sim/ucsim/i8085.src/test/config/Makefile ===
OUTPUTS = I8085


$(OUTPUTS):
	$(call run-sim, -e 'conf; info reg; info mem')


include test-lib.mk

=== sim/ucsim/pblaze.src/test/config/Makefile ===
OUTPUTS = $(filter-out Parameter, $(shell $(SIM) -H | sort -u -k2b | cut -d' ' -f1))


$(OUTPUTS):
	$(call run-sim, -t $(@F) -e 'conf; info reg; info mem')


include test-lib.mk

=== sim/ucsim/pdk.src/test/symdis/Makefile ===
OUTPUTS = stdout


# Ignore changes in white space. The field widths for labels
# depends on the length of the longest label. This will be
# different for different simulators and should not be assumed
# to be constant for any given simulator.
DIFF_OPTS += -b


$(OUTPUTS):	test.ihx test.cmd
	$(call run-sim, -t PDK15)


include test-lib.mk

=== sim/ucsim/s51.src/test/mdu/Makefile ===
OUTPUTS = 517


$(OUTPUTS): %:	test-%.cmd
	$(call run-sim, -t $@)


include test-lib.mk

=== sim/ucsim/sim.src/test/legal/Makefile ===
OUTPUTS = legal


legal: legal.cmd
	$(call run-sim)


include test-lib.mk

=== sim/ucsim/stm8.src/test/clk/Makefile ===
OUTPUTS = stdout

TYPE = S005


stdout:	test.cmd test.ihx
	$(call run-sim)


include test-lib.mk

=== sim/ucsim/stm8.src/test/vcd-in/Makefile ===
OUTPUTS = stdout


# N.B. We name and open the input VCD file here because if this
# is an out-of-tree build we want make to tell us the pathname.
$(OUTPUTS):	test.cmd test.ihx test.vcd
	$(call run-sim, -e 'set hw vcd input "$(filter %.vcd,$+)"')


include test-lib.mk

=== debian/changelog ===
sdcc (4.4.0+dfsg-2) unstable; urgency=medium

  * Include libexec/…/cc1 (Closes: #1067263)

 -- Jonathan McDowell <noodles@earth.li>  Wed, 20 Mar 2024 22:01:35 +0000

sdcc (4.4.0+dfsg-1) unstable; urgency=medium

  * New upstream release
    * Update for ucsim_ renames on simulators
  * Pull in upstream fix for builds with LyX 2.4 (Closes: #1064731)
  * Add missing sdas6500 (Closes: #1057130)
  * Move to debhelper compat level 13
  * Switch from libncurses5-dev to libncurses-dev build-dep
  * Add lintian override for missing-source false positive
    (sim/ucsim/doc/cmd_general.html)
  * Switch as2gbmap over to Python 3
  * Update [git-import-orig] to [import-orig] for debian/gbp.conf

 -- Jonathan McDowell <noodles@earth.li>  Mon, 18 Mar 2024 10:54:34 +0000

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,29 @@
 Source: sdcc
 Section: electronics
 Priority: optional
-Maintainer: Osmocom team <openbsc@lists.osmocom.org>
+Maintainer: Debian Electronics Packaging Team <pkg-electronics-devel@alioth-lists.debian.net>
 Uploaders: Gudjon I. Gudjonsson <gudjon@gudjon.org>,
 	Jonathan McDowell <noodles@earth.li>
 Build-Depends: bison,
-               debhelper (>= 10),
+               debhelper-compat (= 13),
                dpkg-dev (>= 1.16.1~),
                flex,
                gputils,
                libboost-dev,
-               libncurses5-dev,
+               libncurses-dev,
                libtool,
+               texinfo,
                zlib1g-dev
+Build-Depends-Indep: ghostscript,
+                     graphicsmagick-imagemagick-compat,
+                     lyx,
+                     texlive-fonts-recommended,
+                     texlive-font-utils,
+                     texlive-plain-generic,
+                     texlive-latex-recommended,
+                     texlive-latex-extra,
+                     gsfonts,
+                     librsvg2-bin
 Standards-Version: 4.4.1
 Homepage: http://sdcc.sourceforge.net
 Vcs-Git: https://salsa.debian.org/electronics-team/sdcc.git
@@ -23,7 +34,8 @@
 Depends: sdcc-libraries (= ${source:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
-Suggests: python, sdcc-ucsim
+Recommends: sdcc-doc
+Suggests: python3, sdcc-ucsim
 Breaks: sdcc-ucsim (<< 3.5.0)
 Replaces: sdcc-ucsim (<< 3.5.0)
 Description: Small Device C Compiler
@@ -52,3 +64,16 @@
  uCsim is a microcontroller simulator. It is extensible to support
  different microcontroller families. It currently supports Intel
  MCS51 family, HC08 and Z80 microcontrollers.
+
+Package: sdcc-doc
+Section: doc
+Architecture: all
+Multi-Arch: foreign
+Depends: ${misc:Depends}
+Suggests: sdcc
+Description: Small Device C Compiler (documentation)
+ SDCC is a C compiler for the Intel MCS51 family, HC08, PIC,
+ GameBoy Z80, DS80S390, Z80, Z180 and STM8 microcontrollers.
+ .
+ This package provides the documentation and examples for the
+ SDCC compiler.

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 export DH_VERBOSE=1
 
-export DEB_BUILD_MAINT_OPTIONS := hardening=+pie,+bindnow
+export DEB_BUILD_MAINT_OPTIONS := hardening=+pie,+bindnow optimize=-lto
 export CPPFLAGS=$(shell dpkg-buildflags --get CPPFLAGS)
 export CFLAGS=$(shell dpkg-buildflags --get CFLAGS)
 export CXXFLAGS=$(shell dpkg-buildflags --get CXXFLAGS)
@@ -136,6 +136,9 @@
 	rm -f $(CURDIR)/debian/tmp/usr/bin/sdldz80
 	cd $(CURDIR)/debian/tmp/usr/bin/ && ln -s sdld sdldz80
 
+	# s51 == ucsim_51
+	rm -f $(CURDIR)/debian/tmp/usr/bin/s51
+
 	# Remove empty dirs:
 	find $(CURDIR)/debian/tmp -type d -empty -delete
 
@@ -147,7 +150,8 @@
 	install -o root -g root -m 755  support/scripts/*.py debian/tmp/usr/share/sdcc/scripts
 	# Remove an unnecessary script 
 	rm -f debian/tmp/usr/share/sdcc/scripts/gen_known_bugs.pl
-	dh_install -a --sourcedir=debian/tmp --list-missing
+	dh_install -a --sourcedir=debian/tmp
+	dh_missing --list-missing
 
 	touch $@

## sdcc 4.5.0%2Bdfsg

=== sim/ucsim/src/sims/m6809.src/test/config/Makefile ===
OUTPUTS = M6809


$(OUTPUTS):
	$(call run-sim, -e 'conf; info reg; info mem')


include test-lib.mk

## sdcc 4.5.0+dfsg

=== support/tests/internal/Makefile ===
TOPDIR = ../../..

LIBSOURCE = \
	$(TOPDIR)/src/SDCCutil.c \
	$(TOPDIR)/src/SDCChasht.c \
	$(TOPDIR)/support/util/NewAlloc.c \
	$(TOPDIR)/support/util/SDCCerr.c \
	$(TOPDIR)/src/SDCCmacro.c \
	stubs.c

SOURCES = testpaths.c $(LIBSOURCE)

include $(TOPDIR)/Makefile.common

CFLAGS += -I$(TOPDIR)/src -I$(TOPDIR)/support/util -I$(TOPDIR)

all: all-tests

all-tests: $(OBJ)
	$(CC) -o $@ $(OBJ)

=== sim/ucsim/src/sims/avr.src/test/symdis/Makefile ===
OUTPUTS = stdout


# Ignore changes in white space. The field widths for labels
# depends on the length of the longest label. This will be
# different for different simulators and should not be assumed
# to be constant for any given simulator.
DIFF_OPTS += -b


stdout:	test.ihx test.cmd
	$(call run-sim)


%.p:	%.asm
	asl -L -h -U -olist '$*.lst' -o '$@' '$<'

%.ihx:	%.p
	p2hex -F Intel '$<' '$@'


include test-lib.mk

=== sim/ucsim/src/sims/m6809.src/test/symdis/Makefile ===
OUTPUTS = stdout


# Ignore changes in white space. The field widths for labels
# depends on the length of the longest label. This will be
# different for different simulators and should not be assumed
# to be constant for any given simulator.
DIFF_OPTS += -b


stdout:	test.ihx test.cmd
	$(call run-sim)


include test-lib.mk

=== sim/ucsim/src/sims/m68hc08.src/test/symdis/Makefile ===
OUTPUTS = stdout


# Ignore changes in white space. The field widths for labels
# depends on the length of the longest label. This will be
# different for different simulators and should not be assumed
# to be constant for any given simulator.
DIFF_OPTS += -b


stdout:	test.ihx test.cmd
	$(call run-sim, -t HC08)


include test-lib.mk

=== sim/ucsim/src/sims/m68hc11.src/test/config/Makefile ===
OUTPUTS = M68HC11


$(OUTPUTS):
	$(call run-sim, -e 'conf; info reg; info mem')


include test-lib.mk

=== sim/ucsim/src/sims/m68hc12.src/test/config/Makefile ===
OUTPUTS = $(filter-out Parameter, $(shell $(SIM) -H | sort -u -k2b | cut -d' ' -f1))

$(OUTPUTS):
	$(call run-sim, -e 'conf; info reg; info mem')


include test-lib.mk

=== sim/ucsim/src/sims/s51.src/test/bander/Makefile ===
OUTPUTS = 51


$(OUTPUTS): %:	test-%.cmd
	$(call run-sim, -t $@)


include test-lib.mk

=== sim/ucsim/src/sims/st7.src/test/config/Makefile ===
OUTPUTS = ST7


$(OUTPUTS):
	$(call run-sim, -e 'conf; info reg; info mem')


include test-lib.mk

=== sim/ucsim/src/sims/stm8.src/test/port/Makefile ===
OUTPUTS = stdout


# N.B. We name and open the input VCD file here because if this
# is an out-of-tree build we want make to tell us the pathname.
$(OUTPUTS):	test.cmd test.ihx test-in.vcd
	$(call run-sim, -t S003 -e 'set hw vcd input "$(filter %.vcd,$+)"')


include test-lib.mk

=== sim/ucsim/src/sims/stm8.src/test/stm8-cycles/Makefile ===
DIFF_OPTS += -b
OUTPUTS = stdout

#CPU = stm8
TYPE = S003

$(OUTPUTS):	test.cmd test.ihx
	$(call run-sim)


include test-lib.mk

=== sim/ucsim/src/sims/stm8.src/test/vcd-out/Makefile ===
OUTPUTS = stdout


$(OUTPUTS):	test.cmd test.ihx
	$(call run-sim)


include test-lib.mk

=== sim/ucsim/src/sims/xa.src/test/config/Makefile ===
OUTPUTS = XA


$(OUTPUTS):
	$(call run-sim, -e 'conf; info reg; info mem')


include test-lib.mk

=== debian/changelog ===
sdcc (4.5.0+dfsg-3) unstable; urgency=medium

  * Take #2 at fixing compilation with GCC 15
  * Take #2 at fixing Build-Depends / Build-Depends-Arch
  * Bump Standards-Version to 4.7.2

 -- Jonathan McDowell <noodles@earth.li>  Sun, 07 Sep 2025 17:33:58 +0100

sdcc (4.5.0+dfsg-2) unstable; urgency=medium

  * Fix Build-Depends / Build-Depends-Arch up
  * Fix up compilation with GCC 15 (Closes: #1097865)

 -- Jonathan McDowell <noodles@earth.li>  Sat, 06 Sep 2025 10:10:30 +0100

sdcc (4.5.0+dfsg-1) unstable; urgency=medium

  * New upstream release (Closes: #1095426)
    * Drop patches now in upstream release
    * Update paths post upstream re-org
  * Install sdasf8/sdldf8

 -- Jonathan McDowell <noodles@earth.li>  Fri, 14 Mar 2025 12:02:14 +0000

sdcc (4.4.0+dfsg-3) unstable; urgency=medium

  [ Neils Thykier ]
  * Remove need for root when building the package.

  [ Jonathan McDowell ]
  * Drop explicit disabling of LTO (Closes: #1015659)

 -- Jonathan McDowell <noodles@earth.li>  Tue, 31 Dec 2024 12:29:25 +0000

=== debian/control ===
--- 
+++ 
@@ -4,27 +4,31 @@
 Maintainer: Debian Electronics Packaging Team <pkg-electronics-devel@alioth-lists.debian.net>
 Uploaders: Gudjon I. Gudjonsson <gudjon@gudjon.org>,
 	Jonathan McDowell <noodles@earth.li>
-Build-Depends: bison,
-               debhelper-compat (= 13),
-               dpkg-dev (>= 1.16.1~),
-               flex,
-               gputils,
-               libboost-dev,
-               libncurses-dev,
-               libtool,
-               texinfo,
-               zlib1g-dev
-Build-Depends-Indep: ghostscript,
-                     graphicsmagick-imagemagick-compat,
-                     lyx,
-                     texlive-fonts-recommended,
-                     texlive-font-utils,
-                     texlive-plain-generic,
-                     texlive-latex-recommended,
-                     texlive-latex-extra,
-                     gsfonts,
-                     librsvg2-bin
-Standards-Version: 4.4.1
+Build-Depends: debhelper-compat (= 13),
+Build-Depends-Arch: bison,
+	flex,
+	gputils,
+	libboost-dev,
+	libncurses-dev,
+	libtool,
+	texinfo,
+	zlib1g-dev
+Build-Depends-Indep: bison,
+	flex,
+	ghostscript,
+	graphicsmagick-imagemagick-compat,
+	gsfonts,
+	libboost-dev,
+	librsvg2-bin,
+	lyx,
+	texlive-fonts-recommended,
+	texlive-font-utils,
+	texlive-latex-recommended,
+	texlive-latex-extra,
+	texlive-plain-generic,
+	zlib1g-dev
+Rules-Requires-Root: no
+Standards-Version: 4.7.2
 Homepage: http://sdcc.sourceforge.net
 Vcs-Git: https://salsa.debian.org/electronics-team/sdcc.git
 Vcs-Browser: https://salsa.debian.org/electronics-team/sdcc

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 export DH_VERBOSE=1
 
-export DEB_BUILD_MAINT_OPTIONS := hardening=+pie,+bindnow optimize=-lto
+export DEB_BUILD_MAINT_OPTIONS := hardening=+pie,+bindnow
 export CPPFLAGS=$(shell dpkg-buildflags --get CPPFLAGS)
 export CFLAGS=$(shell dpkg-buildflags --get CFLAGS)
 export CXXFLAGS=$(shell dpkg-buildflags --get CXXFLAGS)
@@ -96,7 +96,7 @@
 	dh_prep
 	$(MAKE) install prefix=$(CURDIR)/debian/tmp/usr
 	mkdir -p debian/tmp/usr/share/doc/sdcc-doc
-	install -o root -g root -m 644 doc/sdccman.pdf debian/tmp/usr/share/doc/sdcc-doc
+	install -m 644 doc/sdccman.pdf debian/tmp/usr/share/doc/sdcc-doc
 	mv debian/tmp/usr/share/doc/sdcc/* debian/tmp/usr/share/doc/sdcc-doc/
 	rm -f debian/tmp/usr/share/doc/sdcc-doc/z80/combined_i186_z80_design.tex
 	rm -f debian/tmp/usr/share/doc/sdcc-doc/z80/Makefile
@@ -146,8 +146,8 @@
 	rm -rf `find $(CURDIR)/debian/tmp -type d -name .deps`
 	# Add some scripts
 	mkdir -p debian/tmp/usr/share/sdcc/scripts
-	install -o root -g root -m 755  support/scripts/*.pl debian/tmp/usr/share/sdcc/scripts
-	install -o root -g root -m 755  support/scripts/*.py debian/tmp/usr/share/sdcc/scripts
+	install -m 755  support/scripts/*.pl debian/tmp/usr/share/sdcc/scripts
+	install -m 755  support/scripts/*.py debian/tmp/usr/share/sdcc/scripts
 	# Remove an unnecessary script 
 	rm -f debian/tmp/usr/share/sdcc/scripts/gen_known_bugs.pl
 	dh_install -a --sourcedir=debian/tmp

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg$// https://qa.debian.org/watch/sf.php/sdcc/sdcc-src-([0-9]\.[0-9]\.[0-9])\.tar\.bz2 debian uupdate
